package x36dsv.sebekji1.cvi2.compute;

import java.rmi.Remote;
import java.rmi.RemoteException;

import sebekji1.cvi2.server.DBExistException;
import sebekji1.cvi2.server.DBNotFoundException;
import sebekji1.cvi2.server.DuplicateKeyException;
import sebekji1.cvi2.server.KeyNotFoundException;


public interface ServerInterface extends Remote {

    /**
     * vype existujc databze
     */
    public String[] listDB() throws RemoteException;

    /**
     * vytvo databzi danho jmna
     */
    public boolean createDB(String dbname) throws DBExistException, RemoteException;

    /**
     * vytvo v databzi nov zznam
     */
    public Integer insert(String dbname, Integer key, String message) throws DBNotFoundException, DuplicateKeyException, RemoteException;

    /**
     * aktualizuje zznam dan klem key na hodnotu message
     */
    public Integer update(String dbname, Integer key, String message) throws DBNotFoundException, KeyNotFoundException, RemoteException;

    /**
     * vrt zprvu psluejc danmu kli
     */
    public DBRecord get(String dbname, Integer key) throws DBNotFoundException, KeyNotFoundException, RemoteException;

    /**
     * vrt pole zznam psluejc danm klm, operace se povede bez chyby
     * pouze tehdy, pokud se povedou najt vechny odpovdi
     */
    public DBRecord[] getA(String dbname, Integer[] key) throws DBNotFoundException, KeyNotFoundException, RemoteException;

    /**
     * zape zmny na disk
     */
    public void flush() throws RemoteException;
}
